import '../lib/dna.dart';
import 'dart:typed_data';

void main(){
  var data = new Uint8List(5);
  print('pointer ${getPointer(data)}');
  print('pointer ${getPointer(data)}');
  print('pointer ${getPointer(data)}');

  print('sizes ${getSizes()}');
  print('sumSt data ${encode(new SumSt(1,2,3))}');

  var sums = new Sums();
  var res =  sums.sumStPtr(new SumSt(1,2,3));
  print('sumStPtr $res');

  var library = loadLibrary('dna');

  freeLibrary(library);
}

@Library('libdna.so', 'dna.dll')
class Sums {
  dynamic lib = new DynamicLibrary<Sums>();

  int sumStPtr(@Param(C_STRUCT) SumSt st) { return lib.sumStPtr(st); }
}

@Struct()
class SumSt {
  @Field(C_CHAR)
  int a;
  @Field(C_INT)
  int c;
  @Field(C_CHAR)
  int b;

  SumSt(this.a, this.b, this.c);
}